program ab
  use sep 
  use sep3d_struct_mod
  type(sep3d), allocatable :: model_s(:)
  type(sep3d)              :: out_s
  integer                  :: nsect 
  integer                  :: dff_axis(9)
  integer                  :: nblock(9)
  integer                  :: noverlap(9)
  integer                  :: naxes
  integer                  :: ierr
  integer,external         :: getch
  integer                  :: isect
  character(len=128)       :: temp_ch
  integer, parameter, private :: dbl=selected_real_kind(10,50)
  integer(kind=dbl)        :: n123,tempi
  real, allocatable        :: model(:)
  

  call sep_init(SOURCE)

  naxes=getch("dff_axis","d",dff_axis)
  if(naxes==0 .or. naxes>9) &
    call seperr("dff_axis not defined")

  ierr=getch("nblock","d",nblock)
  if(ierr/=naxes) then
    write(0,*) naxes,"=dff_axis nblock=",nlock
    call seperr("nblock and noverlap must be same size")
  end if
  
  ierr=getch("noverlap","d",noverlap)
  if(ierr/=naxes) then
    write(0,*) naxes,"=dff_axis noverlap=",nlock
    call seperr("noverlap and noverlap must be same size")
  end if
  
  call from_param("nsect",nsect)


  allocate(model_s(nsect))

  do isect=1,nsect
    temp_ch="tag_sect"
    call partcat(temp_ch,isect)
    call init_sep3d(temp_ch,model_s,"INPUT")
  end do
  
  call init_sep3d(model_s(1),out_s,"SCRATCH")
  
  
  





end program
