program aa
  use sep3d_struct_mod
  use amo_nmo_mod
  use sep
  implicit none
  type(sep3d)        :: in_s
  integer            :: i3,i4,i5
  real,allocatable   :: off(:),in(:,:),out(:,:),x(:),y(:)
  real               :: hx,hy

  call sep_init(SOURCE)

  call init_sep3d("in",in_s,"INPUT")
  call amo_nmo_init(in_s,"vrms",100)
   
  allocate(in(in_s%n(1),in_s%n(2)))
  allocate(out(in_s%n(1),in_s%n(2)))
  allocate(off(in_s%n(2)))
  allocate(x(in_s%n(2)))
  allocate(y(in_s%n(2)))

  do i4=1,in_s%n(2)
    x(i4)=in_s%o(2)+in_s%d(2)*(i4-1)
  end do

   do i5=1,in_s%n(5)
      hy=(i5-1)*in_s%d(5)+in_s%o(5)
      do i4=1,in_s%n(4)
        hx=(i4-1)*in_s%d(4)+in_s%o(4)
        off=2*sqrt(hx**2+hy**2)
        do i3=1,in_s%n(3)
           y=(i3-1)*in_s%d(3)+in_s%o(3)
           call sreed("in",in,size(in)*4)
           out=0
           call nmoit(in,out,x,y,off)
           call srite("out",in,size(out)*4)
        end do
      end do
  end do

end program
