module sects_mod
  use sep3d_struct_mod
  use sep
  type(sep3d),pointer :: models_s(:),out_s
  integer, pointer    :: nblock(:),noverlap(:),dff_axis(:)


  logical function  init_combine(models,nb,no,da,out)
    type(sep3d), pointer :: models(:)
    type(sep3d)          :: out
    integer,pointer      :: nb(:),no(:).na(:)
    integer              :: iaxes,isect,i

    init_combine=.false.
    
    models_s=>models
    nblock=>nb
    noverlap=>no
    dff_axis=>da
   
    call init_sep3d(models_s(1),out_s,"SCRATCH")

    do iaxes=1,size(dff_axis)
      out_s%n(dff_axis(iaxes))=0
      do isect=1,size(models_s)
        out_s%n(dff_axis(iaxes))=out_s%n(dff_axis(iaxes))+ &
          models_s(isect)%n(dff_axis(iaxes))
        if(out_s%o(dff_axis(iaxes))  > models_s(isect)%o(dff_axis(iaxes))) &
          out_s%o(dff_axis(iaxes))=models_s(isect)%o(dff_axis(iaxes))
      end do
    end do
    do iaxes=1,size(noverlap)
      do i=1,size(noverlap)
        if(i/=iaxes) out_s%n(dff_axis(iaxes))=
      end do
    end do


    call sep3d_set_sep3d(out_s)
    out_s   =>out
    init_combine=.true.
  end function




end module
program ab
  use sep 
  use sep3d_struct_mod
  type(sep3d), allocatable :: model_s(:)
  type(sep3d)              :: out_s
  integer                  :: nsect 
  integer                  :: dff_axis(9)
  integer                  :: nblock(9)
  integer                  :: noverlap(9)
  integer                  :: naxes
  integer                  :: ierr
  integer,external         :: getch
  integer                  :: isect
  character(len=128)       :: temp_ch
  integer, parameter, private :: dbl=selected_real_kind(10,50)
  integer(kind=dbl)        :: n123,tempi
  real, allocatable        :: model(:)
  

  call sep_init(SOURCE)

  naxes=getch("dff_axis","d",dff_axis)
  if(naxes==0 .or. naxes>9) &
    call seperr("dff_axis not defined")

  ierr=getch("nblock","d",nblock)
  if(ierr/=naxes) then
    write(0,*) naxes,"=dff_axis nblock=",nlock
    call seperr("nblock and noverlap must be same size")
  end if
  
  ierr=getch("noverlap","d",noverlap)
  if(ierr/=naxes) then
    write(0,*) naxes,"=dff_axis noverlap=",nlock
    call seperr("noverlap and noverlap must be same size")
  end if
  
  call from_param("nsect",nsect)


  allocate(model_s(nsect))

  do isect=1,nsect
    temp_ch="tag_sect"
    call partcat(temp_ch,isect)
    call init_sep3d(temp_ch,model_s,"INPUT")
  end do
  
  call init_sep3d(model_s(1),out_s,"SCRATCH")
  
  
  





end program
