import SEP.op_combo
import SEP.paths
import SEP.solv_reg
import SEP.solv_smp
import SEP.solv_prec




class prec(SEP.solv_prec.solver):
    def __init__(self,name,m,d,op,prec,stepper,niter,eps,wop=None,rm0=None,
       m0=None,resd=None,verb=None,restart=None,rmov=None,mmov=None):
       SEP.solv_prec.solver.__init__(self,name,m,d,op,prec,stepper,niter,eps,wop,rm0,
       m0,resd,verb,restart)
       self.mmov=mmov;
       self.niter=niter
       self.mod=m
     
    def end_iter(self,iter):
       if self.mmov: 
         temp_file=self.mod.clone(name="%s.%d"%(self.mmov,int(iter)))
         self.prec.forward(self.p,temp_file)
       return 1


class twerp(SEP.solv_smp.solver):
    def __init__(self,name,m,d,op,prec,stepper,niter,wop=None,rm0=None,
       m0=None,resd=None,verb=None,restart=None,rmov=None,mmov=None):
       new_op=SEP.op_combo.chain("prec_chain",[prec,op],restart)
       p=prec.domain.clone_space(name="%s.prec"%(m.vec_name()))
       print "I AM HERE",restart
       if restart:
         p.restart(1)
       else:
         p.zero()
       self.mod=m
       self.mmov=mmov
       self.prec=prec
       self.niter=niter
       SEP.solv_smp.solver.__init__(self,name,p,d,new_op,stepper,niter,wop,
       verb=verb,restart=restart)
     
    def end_iter(self,iter):
       if self.mmov: 
         temp_file=self.mod.clone(name="%s.%d"%(self.mmov,int(iter)))
         self.prec.forward(self.m,temp_file)
       return 1
    def solve(self):
      """Solve for a model"""
      if not self.iter(): return None
      self.prec.forward(self.m,self.mod)
      return 1
